(* $Id: xlib.mli,v 1.16 2008/12/11 14:11:33 deraugla Exp $ *)

type display = 'a
and colormap = 'a
and gC = 'a
and visual = 'a
and xAtom = 'a
and xEvent = 'a
and drawable = 'a
and xFontStruct = 'a
and xFontSet = 'a
and xfont = 'a
and xSetWindowAttributes = 'a
and xGCValues = 'a
and xWindowChanges = 'a
and xColor = 'a
and xWMHints = 'a
and xAnyEvent = 'a
and xImage = 'a
and xPoint = 'a
and xCrossingEvent = 'a
and xButtonEvent = 'a
and xClientMessageEvent = 'a
and xConfigureEvent = 'a
and xGraphicsExposeEvent = 'a
and xExposeEvent = 'a
and xKeyEvent = 'a
and xMappingEvent = 'a
and xMotionEvent = 'a
and xFocusChangeEvent = 'a
and xSizeHints = 'a
and longRef = 'a
and cursor = 'a
and xKeyboardControl = 'a
and xKeyboardState = 'a
and xID = 'a;
type window = drawable
and xpixmap = drawable;
type gContext = xID;
type atom = int
and time = int
and keySym = int
and status = int;
type c_String = 'a;
type mLimage = 'a;
type fd_set = 'a;

exception X_failure of string;
exception X_io_error of string and string;

value above : int;
value always : int;
value button1Mask : int;
value button2Mask : int;
value button3Mask : int;
value button4Mask : int;
value button5Mask : int;
value button2MotionMask : int;
value buttonMotionMask : int;
value buttonPress : int;
value buttonPressMask : int;
value buttonRelease : int;
value buttonReleaseMask : int;
value cWBackingStore : int;
value cWBitGravity : int;
value cWOverrideRedirect : int;
value cWSaveUnder : int;
value cWStackMode : int;
value cWX : int;
value cWY : int;
value northWestGravity : int;
value capButt : int;
value capNotLast : int;
value capProjecting : int;
value capRound : int;
value clientMessage : int;
value configureNotify : int;
value controlMask : int;
value convex : int;
value coordModeOrigin : int;
value currentTime : time;
value directColor : int;
value allocNone : int;
value doBlue : int;
value doGreen : int;
value doRed : int;
value enterNotify : int;
value enterWindowMask : int;
value expose : int;
value exposureMask : int;
value fillOpaqueStippled : int;
value fillSolid : int;
value fillStippled : int;
value fillTiled : int;
value focusChangeMask : int;
value focusIn : int;
value focusOut : int;
value gCBackground : int;
value gCCapStyle : int;
value gCFillStyle : int;
value gCFont : int;
value gCForeground : int;
value gCLineWidth : int;
value gCStipple : int;
value gCTile : int;
value graphicsExpose : int;
value grayScale : int;
value inputHint : int;
value joinBevel : int;
value joinMiter : int;
value joinRound : int;
value kBBellDuration : int;
value kBBellPercent : int;
value kBBellPitch : int;
value keyPress : int;
value keyPressMask : int;
value lSBFirst : int;
value leaveNotify : int;
value leaveWindowMask : int;
value lineSolid : int;
value lineOnOffDash : int;
value lockMask : int;
value mappingNotify : int;
value mod1Mask : int;
value mod2Mask : int;
value mod3Mask : int;
value mod4Mask : int;
value mod5Mask : int;
value motionNotify : int;
value nonconvex : int;
value noExpose : int;
value notifyInferior : int;
value notifyPointer : int;
value notifyVirtual : int;
value notifyNonlinearVirtual : int;
value ownerGrabButtonMask : int;
value pBaseSize : int;
value pMinSize : int;
value pPosition : int;
value pResizeInc : int;
value pSize : int;
value pointerMotionMask : int;
value pseudoColor : int;
value revertToNone : int;
value shiftMask : int;
value staticColor : int;
value staticGray : int;
value structureNotifyMask : int;
value substructureNotifyMask : int;
value trueColor : int;
value uSPosition : int;
value uSSize : int;
value visibilityChangeMask : int;
value xA_PRIMARY : atom;
value xNone : drawable;
value xYBitmap : int;
value xYPixmap : int;
value zPixmap : int;

(* X functions *)
value isModifierKey : keySym -> bool;
external xAllocColor : (display * colormap * xColor) -> status =
  "ML_XAllocColor";
external xAllocColorCells :
  (display * colormap * int * longRef * int * longRef * int) -> status =
    "ML_XAllocColorCells";
external xAllocNamedColor :
  (display * colormap * string * xColor * xColor) -> status =
    "ML_XAllocNamedColor";
external xBell : (display * int) -> unit = "ML_XBell";
external xBlackPixel : (display * int) -> int = "ML_XBlackPixel";
external xChangeKeyboardControl :
  (display * int * xKeyboardControl) -> unit = "ML_XChangeKeyboardControl";
external xChangeWindowAttributes :
  (display * window * int * xSetWindowAttributes) -> unit =
    "ML_XChangeWindowAttributes";
external xCheckMaskEvent : (display * int * xEvent) -> int =
  "ML_XCheckMaskEvent";
external xClearArea :
  (display * window * int * int * int * int * int) -> unit = "ML_XClearArea";
external xClearWindow : (display * window) -> unit = "ML_XClearWindow";
external xCloseDisplay : display -> unit = "ML_XCloseDisplay";
external xConfigureWindow :
  (display * window * int * xWindowChanges) -> unit = "ML_XConfigureWindow";
external xConnectionNumber : display -> int = "ML_XConnectionNumber";
external xCopyArea :
  (display * drawable * drawable * gC * int * int * int * int * int * int) ->
    unit =
    "ML_XCopyArea";
external xCreateBitmapFromData :
  (display * drawable * string * int * int) -> xpixmap =
    "ML_XCreateBitmapFromData";
external xCreateColormap :
  (display * window * visual * int) -> colormap =
    "ML_XCreateColormap";
external xCreateFontCursor : (display * int) -> cursor =
  "ML_XCreateFontCursor";
external xCreateFontSet : (display * string) -> xFontSet =
  "ML_XCreateFontSet";
external xCreateGC : (display * window * int * xGCValues) -> gC =
  "ML_XCreateGC";
external xCreateImageNullData :
  (display * visual * int * int * int * int * int * int * int) -> xImage =
    "ML_XCreateImageNullData";
external xCreatePixmap : (display * drawable * int * int * int) -> xpixmap =
  "ML_XCreatePixmap";
external xCreatePixmapCursor :
  (display * xpixmap * xpixmap * xColor * xColor * int * int) -> cursor =
    "ML_XCreatePixmapCursor";
external xCreatePixmapFromBitmapData :
  (display * drawable * string * int * int * int * int * int) -> xpixmap =
    "ML_XCreatePixmapFromBitmapData";
external xCreateSimpleWindow :
  (display * window * int * int * int * int * int * int * int) -> window =
    "ML_XCreateSimpleWindow";
external xDefaultColormap : (display * int) -> colormap =
  "ML_XDefaultColormap";
external xDefaultDepth : (display * int) -> int = "ML_XDefaultDepth";
external xDefaultGC : (display * int) -> gC = "ML_XDefaultGC";
external xDefaultRootWindow : display -> window = "ML_XDefaultRootWindow";
external xDefaultScreen : display -> int = "ML_XDefaultScreen";
external xDefaultVisual : (display * int) -> visual = "ML_XDefaultVisual";
external xDefineCursor : (display * window * cursor) -> unit =
  "ML_XDefineCursor";
external xDestroyImage : xImage -> unit = "ML_XDestroyImage";
external xDestroyWindow : (display * window) -> unit = "ML_XDestroyWindow";
external xDisplayHeight : (display * int) -> int = "ML_XDisplayHeight";
external xDisplayName : string -> c_String = "ML_XDisplayName";
external xDisplayWidth : (display * int) -> int = "ML_XDisplayWidth";
external xDrawArc :
  (display * drawable * gC * int * int * int * int * int * int) -> unit =
    "ML_XDrawArc";
external xDrawImageString :
  (display * drawable * gC * int * int * string * int) -> unit =
    "ML_XDrawImageString";
external xDrawLine :
  (display * drawable * gC * int * int * int * int) -> unit = "ML_XDrawLine";
external xDrawLines :
  (display * drawable * gC * xPoint * int * int) -> unit = "ML_XDrawLines";
external xDrawPoint : (display * drawable * gC * int * int) -> unit =
  "ML_XDrawPoint";
external xDrawRectangle :
  (display * drawable * gC * int * int * int * int) -> unit =
    "ML_XDrawRectangle";
external xDrawString :
  (display * drawable * gC * int * int * string * int) -> unit =
    "ML_XDrawString";
external xFetchBytes : (display * ref int) -> c_String = "ML_XFetchBytes";
external xFillArc :
  (display * drawable * gC * int * int * int * int * int * int) -> unit =
    "ML_XFillArc";
external xFillPolygon :
  (display * drawable * gC * xPoint * int * int * int) -> unit =
    "ML_XFillPolygon";
external xFillRectangle :
  (display * drawable * gC * int * int * int * int) -> unit =
    "ML_XFillRectangle";
external xFlush : display -> unit = "ML_XFlush";
external xFreeColors : (display * colormap * longRef * int * int) -> int =
  "ML_XFreeColors";
external xFreeCursor : (display * cursor) -> unit = "ML_XFreeCursor";
external xFreeFont : (display * xFontStruct) -> unit = "ML_XFreeFont";
external xFreeFontSet : (display * xFontSet) -> unit = "ML_XFreeFontSet";
external xFreeFontInfoSpec : xFontStruct -> unit = "ML_XFreeFontInfoSpec";
external xFreeGC : (display * gC) -> unit = "ML_XFreeGC";
external xFreePixmap : (display * xpixmap) -> unit = "ML_XFreePixmap";
external xGContextFromGC : gC -> gContext = "ML_XGContextFromGC";
external xGetDefault : (display * string * string) -> c_String =
  "ML_XGetDefault";
external xGetImage :
  (display * drawable * int * int * int * int * int * int) -> xImage =
    "ML_XGetImage";
external xGetKeyboardControl : (display * xKeyboardState) -> unit =
  "ML_XGetKeyboardControl";
external xGetPixel : (xImage * int * int) -> int = "ML_XGetPixel";
external xGetPixelWithData : (xImage * string * int * int) -> int =
  "ML_XGetPixelWithData";
external xGetSubImage :
  (display * drawable * int * int * int * int * int * int * xImage * int *
   int) ->
    xImage =
    "ML_XGetSubImage";
external xGetSubImageWithData :
  (display * drawable * int * int * int * int * int * int * xImage * string *
   int * int) ->
    xImage =
    "ML_XGetSubImageWithData";
external xInternAtom : (display * string * bool) -> atom = "ML_XInternAtom";
external xKeycodeToKeysym : (display * int * int) -> keySym =
  "ML_XKeycodeToKeysym";
external xKeysymToString : keySym -> c_String = "ML_XKeysymToString";
external xLoadQueryFont : (display * string) -> xFontStruct =
  "ML_XLoadQueryFont";
external xLookupString : (xEvent * string * int) -> (int * keySym) =
  "ML_XLookupString";
external xMapRaised : (display * window) -> unit = "ML_XMapRaised";
external xMapSubwindows : (display * window) -> unit = "ML_XMapSubwindows";
external xMapWindow : (display * window) -> unit = "ML_XMapWindow";
external xMoveResizeWindow :
  (display * window * int * int * int * int) -> unit =
    "ML_XMoveResizeWindow";
external xMoveWindow : (display * window * int * int) -> unit =
  "ML_XMoveWindow";
external xNextEvent : (display * xEvent) -> unit = "ML_XNextEvent";
external xOpenDisplay : string -> display = "ML_XOpenDisplay";
external xPending : display -> int = "ML_XPending";
external xPutImage :
  (display * drawable * gC * xImage * int * int * int * int * int * int) ->
    unit =
    "ML_XPutImage";
external xPutImageWithData :
  (display * drawable * gC * xImage * string * int * int * int * int * int *
   int) ->
    unit =
    "ML_XPutImageWithData";
external xPutPixel : (xImage * int * int * int) -> unit = "ML_XPutPixel";
external xPutPixelWithData : (xImage * string * int * int * int) -> unit =
  "ML_XPutPixelWithData";
external xQueryColor : (display * colormap * xColor) -> unit =
  "ML_XQueryColor";
external xQueryFont : (display * xID) -> xFontStruct = "ML_XQueryFont";
external xQueryPointer :
  (display * window * ref window * ref window * ref int * ref int * ref int *
   ref int * ref int) ->
    int =
    "ML_XQueryPointer";
external xRaiseWindow : (display * window) -> unit = "ML_XRaiseWindow";
external xRefreshKeyboardMapping : xMappingEvent -> unit =
  "ML_XRefreshKeyboardMapping";
external xReparentWindow : (display * window * window * int * int) -> unit =
  "ML_XReparentWindow";
external xResizeWindow : (display * window * int * int) -> unit =
  "ML_XResizeWindow";
external xSelectInput : (display * window * int) -> unit = "ML_XSelectInput";
external xSetBackground : (display * gC * int) -> unit = "ML_XSetBackground";
external xSetClassHint : (display * window * string * string) -> unit =
  "ML_XSetClassHint";
external xSetClipMask : (display * gC * xpixmap) -> unit = "ML_XSetClipMask";
external xSetClipOrigin : (display * gC * int * int) -> unit =
  "ML_XSetClipOrigin";
external xSetCloseDownMode : (display * int) -> int = "ML_XSetCloseDownMode";
external xSetDashes : (display * gC * int * string * int) -> unit = "ML_XSetDashes";
external xSetFillStyle : (display * gC * int) -> unit = "ML_XSetFillStyle";
external xSetFont : (display * gC * xfont) -> unit = "ML_XSetFont";
external xSetForeground : (display * gC * int) -> unit = "ML_XSetForeground";
external xSetIconName : (display * window * string) -> unit =
  "ML_XSetIconName";
external xSetInputFocus : (display * window * int * time) -> unit =
  "ML_XSetInputFocus";
external xSetLineAttributes :
  (display * gC * int * int * int * int) -> unit = "ML_XSetLineAttributes";
external xSetNormalHints : (display * window * xSizeHints) -> unit =
  "ML_XSetNormalHints";
external xSetPlaneMask : (display * gC * int) -> unit = "ML_XSetPlaneMask";
external xSetSelectionOwner : (display * atom * window * time) -> unit =
  "ML_XSetSelectionOwner";
external xSetStandardProperties :
  (display * window * string * string * xpixmap * string * xSizeHints) ->
    unit =
    "ML_XSetStandardProperties";
external xSetStipple : (display * gC * xpixmap) -> unit = "ML_XSetStipple";
external xSetTile : (display * gC * xpixmap) -> unit = "ML_XSetTile";
external xSetTransientForHint : (display * window * window) -> unit =
  "ML_XSetTransientForHint";
external xSetTSOrigin : (display * gC * int * int) -> unit =
  "ML_XSetTSOrigin";
external xSetWindowBackground : (display * window * int) -> unit =
  "ML_XSetWindowBackground";
external xSetWindowBackgroundPixmap : (display * window * xpixmap) -> unit =
  "ML_XSetWindowBackgroundPixmap";
external xSetWindowBorder : (display * window * int) -> unit =
  "ML_XSetWindowBorder";
external xSetWindowBorderPixmap : (display * window * xpixmap) -> unit =
  "ML_XSetWindowBorderPixmap";
external xSetWMHints : (display * window * xWMHints) -> unit =
  "ML_XSetWMHints";
external xSetWMProtocols : (display * window * xAtom * int) -> status =
  "ML_XSetWMProtocols";
external xStoreBytes : (display * string * int) -> unit = "ML_XStoreBytes";
external xStoreColor : (display * colormap * xColor) -> unit =
  "ML_XStoreColor";
external xStoreName : (display * window * string) -> unit = "ML_XStoreName";
external xSync : (display * int) -> unit = "ML_XSync";
external xTextWidth : (xFontStruct * string * int) -> int = "ML_XTextWidth";
external xUndefineCursor : (display * window) -> unit = "ML_XUndefineCursor";
external xUnmapWindow : (display * window) -> unit = "ML_XUnmapWindow";
external xWhitePixel : (display * int) -> int = "ML_XWhitePixel";

(* alloc C structs *)
external alloc_XAtom : int -> xAtom = "ML_alloc_XAtom";
external alloc_XColor : unit -> xColor = "ML_alloc_XColor";
external alloc_XEvent : unit -> xEvent = "ML_alloc_XEvent";
external alloc_XGCValues : unit -> xGCValues = "ML_alloc_XGCValues";
external alloc_XKeyboardControl : unit -> xKeyboardControl =
  "ML_alloc_XKeyboardControl";
external alloc_XKeyboardState : unit -> xKeyboardState =
  "ML_alloc_XKeyboardState";
external alloc_XPoint : int -> xPoint = "ML_alloc_XPoint";
external alloc_XSetWindowAttributes : unit -> xSetWindowAttributes =
  "ML_alloc_XSetWindowAttributes";
external alloc_XSizeHints : unit -> xSizeHints = "ML_alloc_XSizeHints";
external alloc_XWindowChanges : unit -> xWindowChanges =
  "ML_alloc_XWindowChanges";
external alloc_XWMHints : unit -> xWMHints = "ML_alloc_XWMHints";

(* get C structs *)
external visual_class : visual -> int = "ML_Visual_class";
external xAnyEvent_window : xAnyEvent -> window = "ML_XAnyEvent_window";
external xButtonEvent_button : xButtonEvent -> int =
  "ML_XButtonEvent_button";
external xButtonEvent_state : xButtonEvent -> int = "ML_XButtonEvent_state";
external xButtonEvent_x : xButtonEvent -> int = "ML_XButtonEvent_x";
external xButtonEvent_x_root : xButtonEvent -> int =
  "ML_XButtonEvent_x_root";
external xButtonEvent_y : xButtonEvent -> int = "ML_XButtonEvent_y";
external xButtonEvent_y_root : xButtonEvent -> int =
  "ML_XButtonEvent_y_root";
external xClientMessageEvent_data_l_0 : xClientMessageEvent -> int =
  "ML_XClientMessageEvent_data_l_0";
external xClientMessageEvent_message_type : xClientMessageEvent -> atom =
  "ML_XClientMessageEvent_message_type";
external xColor_blue : xColor -> int = "ML_XColor_blue";
external xColor_green : xColor -> int = "ML_XColor_green";
external xColor_pixel : xColor -> int = "ML_XColor_pixel";
external xColor_red : xColor -> int = "ML_XColor_red";
external xConfigureEvent_border_width : xConfigureEvent -> int =
  "ML_XConfigureEvent_border_width";
external xConfigureEvent_height : xConfigureEvent -> int =
  "ML_XConfigureEvent_height";
external xConfigureEvent_width : xConfigureEvent -> int =
  "ML_XConfigureEvent_width";
external xConfigureEvent_x : xConfigureEvent -> int = "ML_XConfigureEvent_x";
external xConfigureEvent_y : xConfigureEvent -> int = "ML_XConfigureEvent_y";
external xCrossingEvent_detail : xCrossingEvent -> int =
  "ML_XCrossingEvent_detail";
external xCrossingEvent_focus : xCrossingEvent -> int =
  "ML_XCrossingEvent_focus";
external xCrossingEvent_x : xCrossingEvent -> int = "ML_XCrossingEvent_x";
external xCrossingEvent_x_root : xCrossingEvent -> int =
  "ML_XCrossingEvent_x_root";
external xCrossingEvent_y : xCrossingEvent -> int = "ML_XCrossingEvent_y";
external xCrossingEvent_y_root : xCrossingEvent -> int =
  "ML_XCrossingEvent_y_root";
external xEvent_type : xEvent -> int = "ML_XEvent_type";
external xEvent_xany : xEvent -> xAnyEvent = "ML_XEvent_xany";
external xEvent_xbutton : xEvent -> xButtonEvent = "ML_XEvent_xbutton";
external xEvent_xclient : xEvent -> xClientMessageEvent =
  "ML_XEvent_xclient";
external xEvent_xconfigure : xEvent -> xConfigureEvent =
  "ML_XEvent_xconfigure";
external xEvent_xcrossing : xEvent -> xCrossingEvent = "ML_XEvent_xcrossing";
external xEvent_xexpose : xEvent -> xExposeEvent = "ML_XEvent_xexpose";
external xEvent_xfocus : xEvent -> xFocusChangeEvent = "ML_XEvent_xfocus";
external xEvent_xgraphicsexpose : xEvent -> xGraphicsExposeEvent =
  "ML_XEvent_xgraphicsexpose";
external xEvent_xkey : xEvent -> xKeyEvent = "ML_XEvent_xkey";
external xEvent_xmapping : xEvent -> xMappingEvent = "ML_XEvent_xmapping";
external xEvent_xmotion : xEvent -> xMotionEvent = "ML_XEvent_xmotion";
external xExposeEvent_height : xExposeEvent -> int =
  "ML_XExposeEvent_height";
external xExposeEvent_width : xExposeEvent -> int = "ML_XExposeEvent_width";
external xExposeEvent_x : xExposeEvent -> int = "ML_XExposeEvent_x";
external xExposeEvent_y : xExposeEvent -> int = "ML_XExposeEvent_y";
external xExposeEvent_count : xExposeEvent -> int = "ML_XExposeEvent_count";
external xFocusChangeEvent_detail : xFocusChangeEvent -> int =
  "ML_XFocusChangeEvent_detail";
external xFocusChangeEvent_mode : xFocusChangeEvent -> int =
  "ML_XFocusChangeEvent_mode";
external xFontStruct_ascent : xFontStruct -> int = "ML_XFontStruct_ascent";
external xFontStruct_descent : xFontStruct -> int = "ML_XFontStruct_descent";
external xFontStruct_fid : xFontStruct -> xfont = "ML_XFontStruct_fid";
external xFontStruct_max_bounds_ascent : xFontStruct -> int =
  "ML_XFontStruct_max_bounds_ascent";
external xFontStruct_max_bounds_descent : xFontStruct -> int =
  "ML_XFontStruct_max_bounds_descent";
external xGraphicsExposeEvent_count : xGraphicsExposeEvent -> int =
  "ML_XGraphicsExposeEvent_count";
external xGraphicsExposeEvent_height : xGraphicsExposeEvent -> int =
  "ML_XGraphicsExposeEvent_height";
external xGraphicsExposeEvent_width : xGraphicsExposeEvent -> int =
  "ML_XGraphicsExposeEvent_width";
external xGraphicsExposeEvent_x : xGraphicsExposeEvent -> int =
  "ML_XGraphicsExposeEvent_x";
external xGraphicsExposeEvent_y : xGraphicsExposeEvent -> int =
  "ML_XGraphicsExposeEvent_y";
external xImage_data : xImage -> c_String = "ML_XImage_data";
external xKeyboardState_bell_duration : xKeyboardState -> int =
  "ML_XKeyboardState_bell_duration";
external xKeyboardState_bell_percent : xKeyboardState -> int =
  "ML_XKeyboardState_bell_percent";
external xKeyboardState_bell_pitch : xKeyboardState -> int =
  "ML_XKeyboardState_bell_pitch";
external xKeyEvent_keycode : xKeyEvent -> int = "ML_XKeyEvent_keycode";
external xKeyEvent_state : xKeyEvent -> int = "ML_XKeyEvent_state";
external xMotionEvent_x : xMotionEvent -> int = "ML_XMotionEvent_x";
external xMotionEvent_y : xMotionEvent -> int = "ML_XMotionEvent_y";
external xMotionEvent_state : xMotionEvent -> int = "ML_XMotionEvent_state";

(* set C structs *)
external set_XAtom : (atom * xAtom * int) -> unit = "ML_set_XAtom";
external set_XColor_blue : (int * xColor) -> unit = "ML_set_XColor_blue";
external set_XColor_flags : (int * xColor) -> unit = "ML_set_XColor_flags";
external set_XColor_green : (int * xColor) -> unit = "ML_set_XColor_green";
external set_XColor_pixel : (int * xColor) -> unit = "ML_set_XColor_pixel";
external set_XColor_red : (int * xColor) -> unit = "ML_set_XColor_red";
external set_XGCValues_background : (int * xGCValues) -> unit =
  "ML_set_XGCValues_background";
external set_XGCValues_cap_style : (int * xGCValues) -> unit =
  "ML_set_XGCValues_cap_style";
external set_XGCValues_fill_style : (int * xGCValues) -> unit =
  "ML_set_XGCValues_fill_style";
external set_XGCValues_font : (xfont * xGCValues) -> unit =
  "ML_set_XGCValues_font";
external set_XGCValues_foreground : (int * xGCValues) -> unit =
  "ML_set_XGCValues_foreground";
external set_XGCValues_line_width : (int * xGCValues) -> unit =
  "ML_set_XGCValues_line_width";
external set_XGCValues_stipple : (xpixmap * xGCValues) -> unit =
  "ML_set_XGCValues_stipple";
external set_XGCValues_tile : (xpixmap * xGCValues) -> unit =
  "ML_set_XGCValues_tile";
external set_XImage_bitmap_bit_order : (int * xImage) -> unit =
  "ML_set_XImage_bitmap_bit_order";
external set_XImage_byte_order : (int * xImage) -> unit =
  "ML_set_XImage_byte_order";
external set_XKeyboardControl_bell_duration :
  (int * xKeyboardControl) -> unit = "ML_set_XKeyboardControl_bell_duration";
external set_XKeyboardControl_bell_percent :
  (int * xKeyboardControl) -> unit = "ML_set_XKeyboardControl_bell_percent";
external set_XKeyboardControl_bell_pitch : (int * xKeyboardControl) -> unit =
  "ML_set_XKeyboardControl_bell_pitch";
external set_XPoint_x : (int * xPoint * int) -> unit = "ML_set_XPoint_x";
external set_XPoint_y : (int * xPoint * int) -> unit = "ML_set_XPoint_y";
external set_XSetWindowAttributes_backing_store :
  (int * xSetWindowAttributes) -> unit =
    "ML_set_XSetWindowAttributes_backing_store";
external set_XSetWindowAttributes_bit_gravity :
  (int * xSetWindowAttributes) -> unit =
    "ML_set_XSetWindowAttributes_bit_gravity";
external set_XSetWindowAttributes_override_redirect :
  (int * xSetWindowAttributes) -> unit =
    "ML_set_XSetWindowAttributes_override_redirect";
external set_XSetWindowAttributes_save_under :
  (int * xSetWindowAttributes) -> unit =
    "ML_set_XSetWindowAttributes_save_under";
external set_XSizeHints_base_width : (int * xSizeHints) -> unit =
  "ML_set_XSizeHints_base_width";
external set_XSizeHints_base_height : (int * xSizeHints) -> unit =
  "ML_set_XSizeHints_base_height";
external set_XSizeHints_flags : (int * xSizeHints) -> unit =
  "ML_set_XSizeHints_flags";
external set_XSizeHints_min_width : (int * xSizeHints) -> unit =
  "ML_set_XSizeHints_min_width";
external set_XSizeHints_min_height : (int * xSizeHints) -> unit =
  "ML_set_XSizeHints_min_height";
external set_XSizeHints_x : (int * xSizeHints) -> unit =
  "ML_set_XSizeHints_x";
external set_XSizeHints_y : (int * xSizeHints) -> unit =
  "ML_set_XSizeHints_y";
external set_XSizeHints_width : (int * xSizeHints) -> unit =
  "ML_set_XSizeHints_width";
external set_XSizeHints_width_inc : (int * xSizeHints) -> unit =
  "ML_set_XSizeHints_width_inc";
external set_XSizeHints_height : (int * xSizeHints) -> unit =
  "ML_set_XSizeHints_height";
external set_XSizeHints_height_inc : (int * xSizeHints) -> unit =
  "ML_set_XSizeHints_height_inc";
external set_XWMHints_flags : (int * xWMHints) -> unit =
  "ML_set_XWMHints_flags";
external set_XWMHints_input : (int * xWMHints) -> unit =
  "ML_set_XWMHints_input";
external set_XWindowChanges_stack_mode : (int * xWindowChanges) -> unit =
  "ML_set_XWindowChanges_stack_mode";
external set_XWindowChanges_x : (int * xWindowChanges) -> unit =
  "ML_set_XWindowChanges_x";
external set_XWindowChanges_y : (int * xWindowChanges) -> unit =
  "ML_set_XWindowChanges_y";

external c_String_length : c_String -> int = "ML_C_String_length";
external fD_ISSET : (int * fd_set) -> int = "ML_FD_ISSET";
external fD_SET : (int * fd_set) -> unit = "ML_FD_SET";
external fD_ZERO : fd_set -> unit = "ML_FD_ZERO";

external mLimage_of_XImage : xImage -> mLimage = "ML_MLimage_of_XImage";

external alloc_LongRef : unit -> longRef = "ML_alloc_LongRef";
external longRef_value : longRef -> int = "ML_LongRef_value";
external set_longRef_value : (int * longRef) -> unit = "ML_set_LongRef_value";

external null_XGCValues : unit -> xGCValues = "ML_null_pt";

external alloc_fd_set : unit -> fd_set = "ML_alloc_fd_set";
external free : 'a -> unit = "ML_free"; (* C free *)
external fselect : (int * fd_set * int) -> int = "ML_fselect";
external is_null_Display : display -> bool = "ML_is_null_pt";
external is_null_XFontStruct : xFontStruct -> bool = "ML_is_null_pt";
external is_null_C_String : c_String -> bool = "ML_is_null_pt";
external set_xerror_exn : (exn * exn) -> unit = "ML_set_xerror_exn";
external string_of_C_String : (c_String * int) -> string =
  "ML_string_of_C_String";
external read : int -> string -> int -> int = "ML_read";
external ioctl_winsz : int -> int -> int -> int -> int -> unit =
  "ML_ioctl_winsz";

external mL_ctime : unit -> int = "ML_ctime";
external mL_ctime_ms : unit -> int = "ML_ctime_ms";
